#include <windows.h>
#include <stdio.h>
#include <ddraw.h>

#define EXPORT extern "C" __declspec(dllexport) 

#include "define_data.h"
#include "define_char.h"
#include "character.h"

//===========================================================
char charactername[32]="صȺ";//O
CCharacter *pchar[2]={NULL,NULL};

void CommandA1(){if(pchar[0]!=NULL)pchar[0]->Command();}
void CommandA2(){if(pchar[1]!=NULL)pchar[1]->Command();}
BOOL CommandB1(DWORD wid){
	if(pchar[0]!=NULL)return(pchar[0]->CommandCOM(wid));
	else return(FALSE);}
BOOL CommandB2(DWORD wid){
	if(pchar[1]!=NULL)return(pchar[1]->CommandCOM(wid));
	else return(FALSE);}
void Action1(){if(pchar[0]!=NULL)pchar[0]->Action();}
void Action2(){if(pchar[1]!=NULL)pchar[1]->Action();}
DWORD TouchA1(LPVOID info){
	if(pchar[0]!=NULL){return(pchar[0]->TouchA((ATTACKINFO*)info));}
	return(0);}
DWORD TouchA2(LPVOID info){
	if(pchar[1]!=NULL){return(pchar[1]->TouchA((ATTACKINFO*)info));}
	return(0);}
DWORD TouchB1(LPVOID info,BOOL hit){
	if(pchar[0]!=NULL){return(pchar[0]->TouchB((ATTACKINFO*)info,hit));}
	return(0);}
DWORD TouchB2(LPVOID info,BOOL hit){
	if(pchar[1]!=NULL){return(pchar[1]->TouchB((ATTACKINFO*)info,hit));}
	return(0);}
void DeleteChar1(){delete(pchar[0]);}
void DeleteChar2(){delete(pchar[1]);}
void InitChar1(){if(pchar[0]!=NULL)pchar[0]->InitChar();}
void InitChar2(){if(pchar[1]!=NULL)pchar[1]->InitChar();}


//===========================================================
//NɌĂяoB
EXPORT BOOL CharacterInfo(LPVOID info)
{
	CHARACTERINFO *pif = (CHARACTERINFO*)info;
	sprintf(pif->name,charactername);
	pif->ver = DLL_VERSION;
	return(TRUE);
}

EXPORT BOOL CreateCharacter(DWORD cid,PVOID info)
{
	CHARACTERINFO2 *pdat;
	pdat = (CHARACTERINFO2*)info;

	if(cid==0){
		pdat->command_a = CommandA1;
		pdat->command_b = CommandB1;
		pdat->action    = Action1;
		pdat->touch_a	= TouchA1;
		pdat->touch_b	= TouchB1;
		pdat->initchar	= InitChar1;
		pdat->deletechar= DeleteChar1;
	}
	else if(cid==1){
		pdat->command_a = CommandA2;
		pdat->command_b = CommandB2;
		pdat->action    = Action2;
		pdat->touch_a	= TouchA2;
		pdat->touch_b	= TouchB2;
		pdat->initchar	= InitChar2;
		pdat->deletechar= DeleteChar2;
	}
	else return(FALSE);

	pchar[cid] = new CCharacter(pdat);
	return(TRUE);
}
